﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private InteractionArguments tempTrackArguments;
        private InteractionArguments tempEditArguments;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void WpfMap_Loaded(object sender, RoutedEventArgs e)
        {
            wpfMap1.MapUnit = GeographyUnit.DecimalDegree;
            wpfMap1.CurrentExtent = new RectangleShape(-133.2515625, 89.2484375, 126.9046875, -88.290625);

            WorldMapKitWmsWpfOverlay worldMapKitOverlay = new WorldMapKitWmsWpfOverlay();
            wpfMap1.Overlays.Add(worldMapKitOverlay);

            wpfMap1.TrackOverlay.MapKeyDown += new System.EventHandler<MapKeyDownInteractiveOverlayEventArgs>(TrackOverlay_MapKeyDown);
            wpfMap1.TrackOverlay.MapMouseMove += new System.EventHandler<MapMouseMoveInteractiveOverlayEventArgs>(TrackOverlay_MapMouseMove);
            wpfMap1.EditOverlay.MapKeyDown += new System.EventHandler<MapKeyDownInteractiveOverlayEventArgs>(EditOverlay_MapKeyDown);
            wpfMap1.EditOverlay.MapMouseClick += new System.EventHandler<MapMouseClickInteractiveOverlayEventArgs>(EditOverlay_MapMouseClick);
            tempTrackArguments = new InteractionArguments();
            tempEditArguments = new InteractionArguments();
            wpfMap1.Focus();

            wpfMap1.Refresh();
        }

        private void EditOverlay_MapMouseClick(object sender, MapMouseClickInteractiveOverlayEventArgs e)
        {
            if (wpfMap1.TrackOverlay.TrackMode == TrackMode.None)
            {
                tempEditArguments = e.InteractionArguments;
            }
        }

        private void EditOverlay_MapKeyDown(object sender, MapKeyDownInteractiveOverlayEventArgs e)
        {
            if (wpfMap1.TrackOverlay.TrackMode == TrackMode.None)
            {
                if (e.InteractionArguments.Key == "Delete")
                {
                    InteractiveResult interactiveResult = wpfMap1.EditOverlay.MouseDoubleClick(tempEditArguments);
                    wpfMap1.Refresh();
                }
            }
        }

        private void TrackOverlay_MapMouseMove(object sender, MapMouseMoveInteractiveOverlayEventArgs e)
        {
            if (wpfMap1.TrackOverlay.TrackMode == TrackMode.Polygon)
            {
                tempTrackArguments = e.InteractionArguments;
            }
        }

        private void TrackOverlay_MapKeyDown(object sender, MapKeyDownInteractiveOverlayEventArgs e)
        {
            if (wpfMap1.TrackOverlay.TrackMode == TrackMode.Polygon)
            {
                if (e.InteractionArguments.Key == "Return")
                {
                    wpfMap1.TrackOverlay.MouseDoubleClick(tempTrackArguments);
                }
            }
        }

        private void button_Click(object sender, RoutedEventArgs e)
        {
            Button button = sender as Button;
            if (button != null)
            {
                switch (button.Name)
                {
                    case "btnTrackPolygon":
                        wpfMap1.TrackOverlay.TrackMode = TrackMode.Polygon;
                        break;
                    case "btnTrackEdit":
                        wpfMap1.TrackOverlay.TrackMode = TrackMode.None;
                        foreach (Feature feature in wpfMap1.TrackOverlay.TrackShapeLayer.InternalFeatures)
                        {
                            wpfMap1.EditOverlay.EditShapesLayer.InternalFeatures.Add(feature);
                        }

                        wpfMap1.TrackOverlay.TrackShapeLayer.InternalFeatures.Clear();
                        wpfMap1.EditOverlay.CalculateAllControlPoints();
                        wpfMap1.Refresh(new Overlay[] { wpfMap1.EditOverlay, wpfMap1.TrackOverlay });
                        break;
                    default:
                        wpfMap1.TrackOverlay.TrackMode = TrackMode.None;
                        break;
                }
            }

            wpfMap1.Focus();
        }
    }
}
